/* Beispiel-Programm zu RSQA */

/* Ist ein ziemlich primitives Programm. Reicht aber um den Area-Header
   anzuzeigen. Nachdem das geschehen ist, kann man den Header, die
   CTRL-Lines und die Lnge des restlichen Textes anzeigen  */

msgarea   = 'G:\YB_MSG\SQ\OS2WPSGE'      /* Rootname */
format    = '$'                          /* Area-Format (hier Squish) */


/************ SEHR WICHTIG !!!!!!!!!! **************/
numeric digits 10      /* oder hher */
/************ SEHR WICHTIG !!!!!!!!!! **************/


if rxfuncquery('sysloadfuncs') <> 0
  then
  do
    call rxfuncadd 'sysloadfuncs', 'rexxutil', 'sysloadfuncs'
    call sysloadfuncs
  end


if sq_init() < 0
  then
  do
    say 'Initialisierungsfehler'
    exit
  end


n = 1                /* Nummer, unter der die Area geffnet wird */
m = 1                /* Nummer, unter der jeweils eine MSG geffnet wird */


say 'sq_open_area      ' sq_open_area(n, msgarea, format)
if sq._result < 0
  then
  do
    say 'Fehler beim ffnen der Area'
    exit
  end

say
say 'Kenndaten der Area'
say '-------------------------------------------------------------------'
if sq._format.n = '$'
  then
  do
    say 'sq._hdr_len.n            ' sq._hdr_len.n
    say 'sq._hdr_reserved_1.n     ' sq._hdr_reserved_1.n
    say 'sq._hdr_num_msg.n        ' sq._hdr_num_msg.n
    say 'sq._hdr_high_msg.n       ' sq._hdr_high_msg.n
    say 'sq._hdr_skip_msg.n       ' sq._hdr_skip_msg.n
    say 'sq._hdr_high_water.n     ' sq._hdr_high_water.n
    say 'sq._hdr_uid.n            ' sq._hdr_uid.n
    say 'sq._hdr_begin_frame.n    ' sq._hdr_begin_frame.n
    say 'sq._hdr_last_frame.n     ' sq._hdr_last_frame.n
    say 'sq._hdr_free_frame.n     ' sq._hdr_free_frame.n
    say 'sq._hdr_last_free_frame.n' sq._hdr_last_free_frame.n
    say 'sq._hdr_end_frame.n      ' sq._hdr_end_frame.n
    say 'sq._hdr_max_msg.n        ' sq._hdr_max_msg.n
    say 'sq._hdr_keep_days.n      ' sq._hdr_keep_days.n
    say 'sq._hdr_sz_sqhdr.n       ' sq._hdr_sz_sqhdr.n
  end
  else
  do
    say 'sq._sdm_high.n           ' sq._sdm_high.n
    say 'sq._sdm_idx.n.0          ' sq._sdm_idx.n.0
    say 'sq._sdm_sort.n           ' sq._sdm_sort.n
  end
say '-------------------------------------------------------------------'


addr_flag = 2
do forever
  call charout, '[+] next   [-] prev   [num] Nr.   [<] Exit: '
  pull a
  say
  if a = ''
    then leave
  say 'sq._open_msg             ' sq_open_msg(n, m, a, addr_flag)
  say '-------------------------------------------------------------------'
  if sq._result > 0
    then
    do
      say 'msg._umsgid.m       =' msg._umsgid.m
      say 'msg._from_name.m    =' msg._from_name.m
      say 'msg._dest_name.m    =' msg._dest_name.m
      say 'msg._subject.m      =' msg._subject.m
      say 'msg._ftsc_date.m    =' msg._ftsc_date.m
      say 'msg._replies.m.0    =' msg._replies.m.0
      call charout, '                      '
      do y = 1 to msg._replies.m.0
        call charout, msg._replies.m.y' '
      end; say
      say 'msg._replyto.m      =' msg._replyto.m
      say 'msg._date_arrived.m =' msg._date_arrived.m
      say 'msg._date_written.m =' msg._date_written.m

      say 'msg._attr.m         =' 'Hex' c2x(msg._attr.m)
      temp  = x2b(c2x(right(msg._attr.m, 2, '00'x)))
      mask  = 'URQ ARQ RRC RRQ FRQ XX2 HLD LOC K/S ORP TRS ATT SNT RCV CRA PVT'
      attr  = ''
      do y = 1 to 16
        if substr(temp, y, 1)
          then attr = attr word(mask, y)
      end
      say '                        ' attr

      say 'msg._cost.m         =' msg._cost.m
      say 'msg._times_read.m   =' msg._times_read.m
      say 'msg._utc_ofs.m      =' msg._utc_ofs.m
      say 'msg._dest_addr.m    =' msg._dest_addr.m
      say 'msg._from_addr.m    =' msg._from_addr.m
      say 'msg._src_addr.m     =' msg._src_addr.m
      say '-----------------------------------------------------------'
      say 'Control-Lines'
      say '-----------------------------------------------------------'
      call sq_ctrl_2_stem(m)
      do y = 1 to msg._ctrl.m.0
        say msg._ctrl.m.y
      end
      say '-----------------------------------------------------------'
      say 'sq._read_msg             ' sq_read_msg(n) 'Bytes'
      say '-----------------------------------------------------------'
      say 'sq._close_msg            ' sq_close_msg(n)
    end
  say
end

say 'sq_close_area     ' sq_close_area(n)

exit

/************************************************************************/


/************************************************************************\
*                                                                        *
*                             RSQA v1.04                                 *
*                                                                        *
*       REXX-Funktionen fr den Zugriff auf Squish- und *.MSG-Areas      *
*                                                                        *
*                Autor: Rdiger Wilke 2:2432/214@fidonet                 *
*                                                                        *
\************************************************************************/



sq_init:

arg sq._def_zone

sq._result = 0
select
  when sq._def_zone = ''
    then sq._def_zone = 2
  when \datatype(sq._def_zone, 'w') | sq._def_zone < 1
    then sq._result = -99
  otherwise
end
sq._open_areas = ''
sq._open_msgs  = ''
sq._open_roots = ''

return sq._result

/************************************************************************/

sq_open_msg: procedure expose sq. msg.

arg n, m, ser, addr_flag

numstr = '0123456789'
sq._result = 0
select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when \datatype(m, 'w') | m < 1
    then sq._result = -99         /* Fehler bei Argumenten */
  when sq._msg_current.n > 0
    then sq._result = -5          /* schon eine MSG offen */
  when wordpos(m, sq._open_msgs) > 0
    then sq._result = -6          /* schon eine MSG mit dieser Nr. offen */
  when ser = '+'      
    then ser = sq._msg_last.n +1  /* nchste MSG ffnen */
  when ser = '-'      
    then ser = sq._msg_last.n -1  /* vorherige MSG ffnen */
  when ser = '='      
    then ser = sq._msg_last.n     /* zuletzt geffnete MSG nochmals ffnen */
  when \datatype(ser, 'w') | ser < 1
    then sq._result = -99         /* Fehler bei Argumenten */
  otherwise
end
select
  when sq._result <> 0 | ser < 1
    then nop
  when sq._format.n = '$'
    then if ser <= sq._hdr_num_msg.n
      then call sq_open_msg_sq
  when ser > sq._sdm_idx.n.0
    then nop                    /* *.MSG nicht vorhanden */
  otherwise
    call sq_open_msg_sdm
end

return sq._result



sq_open_msg_sq:

sq._msg_curr_var.n = m
sq._msg_curr_file.n = c2d(reverse(substr(sq._area_idx.n, ser * 12 -11, 4, '0'x)))
select
  when sq._msg_curr_file.n = 0
    then sq._result = -1        /* MSG nicht vorhanden */
  otherwise
                                /* SQHDR einlesen */
    call stream sq._root_sqd.n, 'c', 'seek <'0
    data = charin(sq._root_sqd.n, sq._msg_curr_file.n +1, sq._hdr_sz_sqhdr.n)
    parse value reverse(left(data, 26)) with,
                     frame_type          +2,
                     sq._msg_curr_clen.n +4,
                     sq._msg_curr_len.n  +4,
                  23 sqhdr_id
    select

      when length(data) <> sq._hdr_sz_sqhdr.n  /* Lnge der Daten testen */
        then sq._result = -1
                                /* SQHDR-ID testen */
      when sqhdr_id <> 'afae4453'x
        then sq._result = -1
                                /* Frame-Type testen */
      when frame_type \== '0000'x
        then sq._result = -1
      otherwise
        sq._msg_curr_len.n  = c2d(sq._msg_curr_len.n)
        sq._msg_curr_clen.n = c2d(sq._msg_curr_clen.n)

                                /* XMSG einlesen */
        parse value charin(sq._root_sqd.n,, 238) with ,
                         msg._attr.m       +4,
                         msg._from_name.m +36,
                         msg._dest_name.m +36,
                         msg._subject.m   +72,
                         data             +70,
                         msg._ftsc_date.m

        msg._attr.m      = reverse(msg._attr.m)
        msg._from_name.m = strip(msg._from_name.m,, '0'x)
        msg._dest_name.m = strip(msg._dest_name.m,, '0'x)
        msg._subject.m   = strip(msg._subject.m  ,, '0'x)
        
        if length(msg._ftsc_date.m) = 20
          then
          do
            parse value reverse(data) with,
                              msg._umsgid.m        +4,
                              msg._replies.m.9     +4,   /* Replies */
                              msg._replies.m.8     +4,
                              msg._replies.m.7     +4,
                              msg._replies.m.6     +4,
                              msg._replies.m.5     +4,
                              msg._replies.m.4     +4,
                              msg._replies.m.3     +4,
                              msg._replies.m.2     +4,
                              msg._replies.m.1     +4,
                              msg._replyto.m       +4,   /* restl. Daten */
                              msg._utc_ofs.m       +2,
                              msg._date_arrived.m  +4,
                              msg._date_written.m  +4,
                              d_point              +2,
                              d_node               +2,
                              d_net                +2,
                              d_zone               +2,
                              f_point              +2,
                              f_node               +2,
                              f_net                +2,
                              f_zone               +2,
                            5 y +36                   /* nochmal Replies */

            msg._replies.m.0 = 9 - (compare(y'@', '0'x, '0'x) -1) % 4
            do y = 1 to msg._replies.m.0
              msg._replies.m.y = c2d(msg._replies.m.y)
            end

            msg._umsgid.m       = c2d(msg._umsgid.m)
            msg._replyto.m      = c2d(msg._replyto.m)
            msg._utc_ofs.m      = c2d(msg._utc_ofs.m, 2)
            msg._date_arrived.m = sq_c2datetime(msg._date_arrived.m)
            msg._date_written.m = sq_c2datetime(msg._date_written.m)
            msg._dest_addr.m    = c2d(d_zone) || ':' ||,
                                  c2d(d_net)  || '/' ||,
                                  c2d(d_node) || '.' ||,
                                  c2d(d_point)
            msg._from_addr.m    = c2d(f_zone) || ':' ||,
                                  c2d(f_net)  || '/' ||,
                                  c2d(f_node) || '.' ||,
                                  c2d(f_point)
            msg._ftsc_date.m    = left(strip(msg._ftsc_date.m, 't', '0'x), 19, '0'x)

            msg._times_read.m   = 0
            msg._cost.m         = 0

            /* CTRL-Lines einlesen */

            if sq._msg_curr_clen.n > 0
              then msg._ctrl.m = charin(sq._root_sqd.n,, sq._msg_curr_clen.n -1)
              else msg._ctrl.m = ''

            /* MSGID auswerten */

            select
              when addr_flag < 1
                then msg._src_addr.m = ''
              when msg._ctrl.m = ''
                then msg._src_addr.m = ''
              otherwise
                         /* todo: doch noch INTL etc. auswerten */
                call sq_open_msg_1
            end

            msg._text.m         = ''
            sq._result          = ser
            sq._msg_current.n   = ser
            sq._open_msgs       = sq._open_msgs m

          end
          else sq._result = -1
    end
end

return




sq_open_msg_sdm:

call sq_sort_sdm_idx
sq._msg_curr_var.n = m
sq._msg_curr_file.n = sq._root.n'\'sq._sdm_idx.n.ser'.MSG'

sq._msg_curr_len.n = stream(sq._msg_curr_file.n, 'c', 'query size')
select
  when sq._msg_curr_len.n < 191
    then sq._result = -3        /* MSG ist zu klein oder nicht vorhanden */
  when stream(sq._msg_curr_file.n, 'c', 'open') <> 'READY:'
    then sq._result = -3        /* Fehler beim ffnen */

  otherwise

    parse value charin(sq._msg_curr_file.n,, 190) with ,
                     msg._from_name.m  +36,
                     msg._dest_name.m  +36,
                     msg._subject.m    +72,
                     msg._ftsc_date.m  +20,
                     data

    msg._from_name.m = strip(msg._from_name.m,, '0'x)
    msg._dest_name.m = strip(msg._dest_name.m,, '0'x)
    msg._subject.m   = strip(msg._subject.m  ,, '0'x)
    msg._ftsc_date.m = left(strip(msg._ftsc_date.m, 't', '0'x), 19, '0'x)

    if length(data) = 26
      then
      do
        parse value reverse(data) with,
                     msg._replies.m.1    +2,
                     msg._attr.m         +2,
                     msg._replyto.m      +2,
                     msg._date_arrived.m +4,
                     msg._date_written.m +4,
                     d_net               +2,
                     f_net               +2,
                     msg._cost.m         +2,
                     f_node              +2,
                     d_node              +2,
                     msg._times_read.m   +2

        msg._times_read.m   = c2d(msg._times_read.m)
        msg._cost.m         = c2d(msg._cost.m)
        msg._date_arrived.m = sq_c2datetime(msg._date_arrived.m)
        msg._date_written.m = sq_c2datetime(msg._date_written.m)
        msg._replyto.m      = c2d(msg._replyto.m)
        msg._attr.m         = '0000'x || msg._attr.m
        msg._replies.m.1    = c2d(msg._replies.m.1)
        msg._replies.m.0    = sign(msg._replies.m.1)
        msg._dest_addr.m    = c2d(d_net)'/'c2d(d_node)
        msg._from_addr.m    = c2d(f_net)'/'c2d(f_node)

        msg._utc_ofs.m      = 0
        msg._umsgid.m       = sq._sdm_idx.n.ser

        /* CTRL-Lines einlesen */

        msg._ctrl.m = ''
        sq._msg_curr_clen.n = stream(sq._msg_curr_file.n, 'c', 'seek +0')
        do while lines(sq._msg_curr_file.n) > 0
          data = linein(sq._msg_curr_file.n)
          select
            when left(data, 5) = 'AREA:'
              then msg._ctrl.m = msg._ctrl.m || ''data
            when left(data, 1) <> '' | left(data, 4) = 'Via'
              then leave
            otherwise
              msg._ctrl.m = msg._ctrl.m || data
          end
          sq._msg_curr_clen.n = stream(sq._msg_curr_file.n, 'c', 'seek +0')
        end

        /* CTRL-Lines auswerten */

        select
          when addr_flag < 1
            then msg._src_addr.m = ''
          when msg._ctrl.m <> ''
            then
            do
              call sq_open_msg_1
              if addr_flag = 2
                then call sq_open_msg_sdm_1
            end
          otherwise
            msg._src_addr.m = ''
            if addr_flag = 2
              then
              do
                msg._from_addr.m = sq._def_zone.n':'msg._from_addr.m'.0'
                msg._dest_addr.m = sq._def_zone.n':'msg._dest_addr.m'.0'
              end
        end

        msg._text.m         = ''
        sq._msg_current.n   = ser
        sq._result          = ser
        sq._open_msgs       = sq._open_msgs m

      end
      else sq._result = -3
end

return


sq_open_msg_sdm_1:

parse var msg._ctrl.m 'INTL 'd_zone':'.' 'f_zone':' 1 'TOPT 'd_point'' 1 'FMPT 'f_point''
if verify(f_point, numstr) > 0 | f_point < 0
  then f_point = 0
if verify(d_point, numstr) > 0 | d_point < 0
  then d_point = 0
select
  when d_zone < 1
    then f_zone = ''
  when verify(d_zone, numstr) > 0
    then f_zone = ''
  when f_zone < 1
    then f_zone = ''
  when verify(f_zone, numstr) > 0
    then f_zone = ''
  otherwise
end
if f_zone <> ''
  then
  do
    msg._from_addr.m = f_zone':'msg._from_addr.m'.'f_point
    msg._dest_addr.m = d_zone':'msg._dest_addr.m'.'d_point
  end
  else
  do
    msg._from_addr.m = sq._def_zone.n':'msg._from_addr.m'.'f_point
    msg._dest_addr.m = sq._def_zone.n':'msg._dest_addr.m'.'d_point
  end

return




/* MSGID auswerten */
sq_open_msg_1:
parse var msg._ctrl.m 'MSGID: 'm_zone':'m_net'/'m_node' '.
signal on syntax name sq_open_msg_1_1
if m_zone <> ''
  then
  do
    parse var m_node m_node'@'
    parse var m_node m_node'.'m_point
    m_point = ('0'm_point) +0
    if min(m_zone, m_net, m_node) < 0
      then msg._src_addr.m = ''
      else msg._src_addr.m = m_zone':'m_net'/'m_node'.'m_point
  end
  else msg._src_addr.m = ''
signal off syntax
return

sq_open_msg_1_1:
msg._src_addr.m = ''
signal off syntax
return

/************************************************************************/

sq_read_msg: procedure expose sq. msg.

arg n, addr_flag
sq._result = 0

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when sq._msg_current.n = 0
    then sq._result = -5          /* Keine MSG in der Area offen */
  otherwise
    m = sq._msg_curr_var.n
    select
      when msg._text.m <> ''
        then nop                      /* Text nicht lesen, wenn schon geschehen */
      when sq._format.n = '$'
        then
        do
          p = sq._msg_curr_file.n +sq._hdr_sz_sqhdr.n +238 +sq._msg_curr_clen.n +1
          len = sq._msg_curr_len.n -sq._msg_curr_clen.n -238 -1
          select
            when stream(sq._root_sqd.n, 'c', 'seek <'0) = ''
              then sq._result = -1
            when len < 1
              then msg._text.m = ''
            otherwise
              msg._text.m = charin(sq._root_sqd.n, p, len)
              if length(msg._text.m) <> len
                then sq._result = -1
                else sq._result = len
          end
        end
      otherwise
        len = sq._msg_curr_len.n -sq._msg_curr_clen.n
        if len < 1
          then msg._text.m = ''
          else
          do
            msg._text.m = charin(sq._msg_curr_file.n, sq._msg_curr_clen.n, len)
            if length(msg._text.m) <> len
              then sq._result = -3
              else sq._result = len
          end
    end
end

select
  when addr_flag < 1
    then nop
  when sq._result < 1
    then nop
  when addr_flag = 2
    then msg._src_addr.m = sq_read_msg_1()
  when sq_read_msg_1() <> ''
    then msg._src_addr.m = addr
  otherwise
end
signal off syntax
return sq._result


sq_read_msg_1:
signal on syntax name sq_error_null
parse var msg._text.m ' * Origin: 'addr'd'x
parse value reverse(addr) with ')'addr'('
parse value reverse(addr) with zone':'net'/'node'.'point
point = (0||point) +0
if min(zone, net, node, point) >= 0
  then addr = zone':'net'/'node'.'point
  else addr = ''
return addr

/************************************************************************/

sq_ctrl_2_stem: procedure expose sq. msg.

arg m

select
  when \datatype(m, 'w') | m < 0
    then res = -99
  when symbol('msg._ctrl.m') <> 'VAR'
    then res = -98
  when msg._ctrl.m = ''
    then
    do
      msg._ctrl.m.0 = 0
      res = 0
    end
  otherwise
    s_begin = 1
    do v = 1
      s_next = pos('', msg._ctrl.m, s_begin +1)
      if s_next = 0
        then
        do
          msg._ctrl.m.v = substr(msg._ctrl.m, s_begin)
          leave
        end
      msg._ctrl.m.v = substr(msg._ctrl.m, s_begin, s_next -s_begin)
      s_begin = s_next
    end
    msg._ctrl.m.0 = v
    res = msg._ctrl.m.0
end

return res

/************************************************************************/

sq_stem_2_ctrl: procedure expose sq. msg.

arg m
select
  when \datatype(m, 'w') | m < 0
    then res = -99
  when \datatype(msg._ctrl.m.0, 'w') | msg._ctrl.m.0 < 0
    then res = -98
  otherwise
    msg._ctrl.m = ''
    do y = 1 to msg._ctrl.m.0
      msg._ctrl.m = msg._ctrl.m || msg._ctrl.m.y
    end
    res = msg._ctrl.m.0
end

return res

/************************************************************************/

sq_close_msg: procedure expose sq. msg.

arg n

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when sq._msg_current.n = 0
    then sq._result = -5          /* Keine MSG in der Area offen */
  when sq._format.n <> '$'
    then sq._result = (stream(sq._msg_curr_file.n, 'c', 'close') = 'READY:')
  otherwise
    sq._result = 1
end
if sq._result >= 0
  then
  do
    p = wordpos(sq._msg_curr_var.n, sq._open_msgs)
    if p > 0
      then sq._open_msgs = strip(delword(sq._open_msgs, p, 1))
    sq._msg_last.n = sq._msg_current.n
    sq._msg_current.n = 0
    if sq._result > 0
      then sq._result = sq._msg_last.n
      else sq._result = -3
  end

return sq._result

/************************************************************************/

sq_kill_msg: procedure expose sq. msg.

arg n, ser

sq._result = 0
select
  when wordpos(n, sq._open_areas) = 0   /* Area nicht offen */
    then sq._result = -98
  when \datatype(ser, 'w') | ser < 1    /* Argumentenfehler */
    then sq._result = -99
  when sq._msg_current.n > 0            /* eine MSG ist gerade offen */
    then sq._result = -5
  when sq._format.n = '$'
    then call sq_kill_msg_sq
  otherwise
    call sq_kill_msg_sdm
end
signal off syntax

return sq._result


sq_kill_msg_sq:

/*========================================================================
frame.i     = Frame-Offset
sqhdr.i     = SQHDR-Daten

i = 1       = zu lschender Frame
    2       = nachfolgender Frame
    3       = vorhergehende Frame
    4       = letzter Free-Frame

========================================================================*/

frame.1 = c2d(reverse(substr(sq._area_idx.n, ser * 12 -11, 4, '0'x)))
if frame.1 > 0
  then
  do
    frame.4 = sq._hdr_last_free_frame.n
    select
                      /* notwendige SQHDR-Daten lesen */
                      /* Daten Del-Frame */
      when sq_kill_msg_sq_1(1) > 0
        then sq._result = -1
                      /* Daten Next-Frame */
      when sq_kill_msg_sq_2(2, 3, 9, 0) > 0
        then sq._result = -1
                      /* Daten Prev-Frame */
      when sq_kill_msg_sq_2(3, 2, 5, 0) > 0
        then sq._result = -1
                      /* Daten Last-Free-Frame */
      when sq_kill_msg_sq_2(4, 1, 5, 1) > 0
        then sq._result = -1

      otherwise

        /* Daten Del-Frame anpassen , Zeiger und Frame-Type*/
        sqhdr.1 = overlay('00000000'x || reverse(d2c(frame.4, 4)), left(sqhdr.1, 24) || '0100'x, 5)

        /* Header-Daten anpassen */
        sq._hdr_num_msg.n  = sq._hdr_num_msg.n -1
        sq._hdr_high_msg.n = sq._hdr_high_msg.n -1

        if frame.2 = 0
          then sq._hdr_last_frame.n = frame.3
        if frame.3 = 0
          then sq._hdr_begin_frame.n = frame.2
        if sq._hdr_free_frame.n = 0
          then sq._hdr_free_frame.n = frame.1
        sq._hdr_last_free_frame.n = frame.1

        /* SQI anpassen */
        sq._area_idx.n = delstr(sq._area_idx.n, ser *12 -11, 12)

        /* Daten in *.SQD-File schreiben */
        do y = 1 to 4
          if frame.y > 0
            then
            do
              call stream sq._root_sqd.n, 'c', 'seek <'0
              if charout(sq._root_sqd.n, sqhdr.y, frame.y +1) > 0
                then leave
            end
        end
        select
          when y <= 4
            then sq._result = -1
          when sq_write_header() <> 0
            then sq._result = -1
          otherwise
            sq._result = ser
            sq._modified.n = 1
            if sq._msg_last.n >= ser
              then sq._msg_last.n = 0
        end
    end

  end
  else sq._result = 0   /* MSG nicht vorhanden oder ungltig */

return


                      /* SQHDR-Daten testen */
sq_kill_msg_sq_3:

call stream sq._root_sqd.n, 'c', 'seek <'0
sqhdr.i = charin(sq._root_sqd.n, frame.i +1, 26)
select
                      /* Anzahl der Bytes testen */
  when length(sqhdr.i) <> 26
    then res = 1
                      /* SQHDR-ID testen */
  when left(sqhdr.i, 4) <> '5344aeaf'x
    then res = 2
                      /* Frame-Type testen */
  when c2d(reverse(right(sqhdr.i, 2))) <> ft
    then res = 3
  otherwise
end
return res




/* Daten Frame lesen und Zeiger anpassen
   i    = Index fr den Frame
   fp   = Index des neu einzutragenden Wert (neuer Zeiger-Wert)
   pp   = Position des neuen Wertes in den Frame-Daten (zeiger-Position)
   ft   = geforderter Frame-Type
 */

sq_kill_msg_sq_2:
arg i, fp, pp, ft
if frame.i > 0
  then if sq_kill_msg_sq_3() = 0
    then sqhdr.i = overlay(reverse(d2c(frame.fp, 4)), sqhdr.i, pp)
return res


                      /* notwendige SQHDR-Daten lesen */
sq_kill_msg_sq_1:
arg i     /* i = 1 */
res = 0
ft = 0
if sq_kill_msg_sq_3() = 0
  then
  do
    frame.2 = c2d(reverse(substr(sqhdr.1, 5, 4)))
    frame.3 = c2d(reverse(substr(sqhdr.1, 9, 4)))
  end
return res




sq_kill_msg_sdm:

if ser <= sq._sdm_idx.n.0
  then
  do
    call sq_sort_sdm_idx
    if sysfiledelete(sq._root.n'\'sq._sdm_idx.n.ser'.MSG') = 0
      then
      do
        sq._sdm_idx.n.0 = sq._sdm_idx.n.0 -1
        do y = ser to sq._sdm_idx.n.0
          z = y +1
          sq._sdm_idx.n.y = sq._sdm_idx.n.z
        end
        sq._result = ser
        y = sq._sdm_idx.n.0
        sq._sdm_high.n = sq._sdm_idx.n.y
        if sq._msg_last.n >= ser
          then sq._msg_last.n = 0
      end
      else sq._result = -3
  end
  else sq._result = 0

return

/************************************************************************/

sq_update_msg_hdr: procedure expose sq. msg.

arg n, flag
sq._result = 0
m = sq._msg_curr_var.n
select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when sq._msg_current.n = 0
    then sq._result = -5          /* Keine MSG in der Area offen */
  when sq._format.n = '$'
    then call sq_update_msg_hdr_sq

  when sq_msg_header_test() <> 0
    then nop /* sq._result = -20     Fehler MSG-Header-Daten */
  when charout(sq._msg_curr_file.n, msg_hdr, 1) > 0
    then sq._result = -3
  otherwise
    sq._result = sq._msg_current.n
end
signal off syntax

return sq._result



sq_update_msg_hdr_sq:

parse value reverse(substr(sq._area_idx.n, sq._msg_current.n * 12 -11, 8, '0'x)) with,
      umsgid +4 frame
umsgid = c2d(umsgid)
select
  when umsgid = 0 | c2d(frame) <> sq._msg_curr_file.n
    then sq._result = -2    /* Fehler in den SQI-Daten */
  when sq_msg_header_test(1) <> 0
    then nop /* sq._result = -20     Fehler MSG-Header-Daten */
  otherwise
            /* Zeiger auf Ende der Datei */
    call stream sq._root_sqd.n, 'c', 'seek <'0
    parse value charin(sq._root_sqd.n, sq._msg_curr_file.n +1, sq._hdr_sz_sqhdr.n) with,
            sqhdr_id +4 17 msg_length +4 25 frame_type +2
    select
            /* SQHDR-ID testen */
      when sqhdr_id <> '5344aeaf'x
        then sq._result = -1
            /* Frame-Type testen */
      when frame_type \== '0000'x
        then sq._result = -1
            /* Lnge der MSG testen (min. 238 +1 +1) */
      when c2d(reverse(msg_length)) < 240
        then sq._result = -1
            /* Zeiger-Position testen */
      when stream(sq._root_sqd.n, 'c', 'seek +'0) <> sq._msg_curr_file.n +sq._hdr_sz_sqhdr.n +1
        then sq._result = -1
            /* XMSG schreiben */
      when charout(sq._root_sqd.n, msg_hdr) > 0
        then sq._result = -1
      otherwise
        sq._result = sq._msg_current.n
                                /* Area-Index aktualisieren */
        if flag < 1
          then
          do
            sq._area_idx.n = overlay(reverse(sq_str_hash(msg._dest_name.m,,
                             (bitand('00000004'x, attr) <> '00000000'x))),,
                             sq._area_idx.n, sq._msg_current.n * 12 -3)
            sq._modified.n = 1
          end
    end
end
return

/************************************************************************/

sq_create_msg: procedure expose sq. msg.

arg n, m, ctrl_flag

sq._result = 0
select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98
  when \datatype(m, 'w') | m < 1
    then sq._result = -99
  when sq_msg_header_test(0) <> 0
    then nop /* sq._result = -20     Fehler MSG-Header-Daten */
  otherwise
    call sq_msg_ctrl_mod            /* CTRL-Lines bearbeiten */
    if sq._format.n = '$'
      then call sq_create_msg_sq    /* Squish-MSG erstellen */
      else call sq_create_msg_sdm   /* *.MSG erstellen */
end
signal off syntax

return sq._result



sq_create_msg_sq:

signal on syntax name sq_error_1
prev_frame   = sq._hdr_last_frame.n
sqhdr = left('5344aeaf'x ||,                 /* id */
             '00000000'x ||,                 /* next_frame */
             reverse(d2c(prev_frame, 4)) ||, /* prev_frame */
             '00000000'x ||,                 /* frame_length */
             '00000000'x ||,                 /* msg_length */
             '00000000'x ||,                 /* ctrl_length */
             '0300'x     ,,                  /* frame_type */
             sq._hdr_sz_sqhdr.n, '0'x)

select
                                /* Zeiger auf Dateiende */
  when stream(sq._root_sqd.n, 'c', 'seek <'0) <> sq._hdr_end_frame.n +1
    then sq._result = -1
                                /* SQHDR erstellen */
  when charout(sq._root_sqd.n, sqhdr, sq._hdr_end_frame.n +1) > 0
    then sq._result = -1
                                /* XMSG schreiben */
  when charout(sq._root_sqd.n, msg_hdr) > 0
    then sq._result = -1

  otherwise

    ctrl_length   = length(msg._ctrl.m) +1
    msg_length    = 238 + ctrl_length + length(msg._text.m) +1
    msg_length_c  = reverse(d2c(msg_length, 4))

    select
                                /* CTRL-Lines schreiben */
      when charout(sq._root_sqd.n, msg._ctrl.m || '0'x) > 0
        then sq._result = -1
                                    /* MSG-Text schreiben */
      when charout(sq._root_sqd.n, msg._text.m || '0'x) > 0
        then sq._result = -1
                                /* SQHDR aktualisieren */
      when charout(sq._root_sqd.n, msg_length_c ||,
                   msg_length_c || reverse(d2c(ctrl_length, 4)) ||,
                   '0000'x, sq._hdr_end_frame.n +13) > 0
        then sq._result = -1
                                /* Vorletzte MSG linken */
      when sq_create_msg_sq_1() <> 0
        then nop /* SQ._RESULT = -1 */
      otherwise
                                /* Area-Header-Daten aktualisieren */
        sq._hdr_num_msg.n      = 1+ sq._hdr_num_msg.n
        sq._hdr_high_msg.n     = 1+ sq._hdr_high_msg.n
        sq._hdr_uid.n          = 1+ sq._hdr_uid.n
        sq._hdr_last_frame.n   = sq._hdr_end_frame.n
        sq._hdr_end_frame.n    = sq._hdr_end_frame.n + msg_length + sq._hdr_sz_sqhdr.n
        if sq._hdr_begin_frame.n = 0
          then sq._hdr_begin_frame.n = sq._hdr_last_frame.n
        if sq_write_header() <> 0
          then sq._result = -1
          else
          do
                                /* Area-Index aktualisieren */
            sq._area_idx.n = sq._area_idx.n ||,
                           reverse(sq_str_hash(msg._dest_name.m,,
                               (bitand('00000004'x, attr) <> '00000000'x)) ||,
                             d2c(umsgid, 4)               ||,
                             d2c(sq._hdr_last_frame.n, 4))

            sq._modified.n = 1                  /* MSG-Base wurde gendert */
            sq._result     = sq._hdr_num_msg.n  /* lfd. Nr. der neuen MSG */
          end
    end
end

return


sq_create_msg_sq_1:
if prev_frame > 0
  then if charout(sq._root_sqd.n, reverse(d2c(sq._hdr_end_frame.n, 4)),,
               prev_frame +5) > 0
    then sq._result = -1
return sq._result



sq_create_msg_sdm:

say sq._sdm_high.n n symbol('sq._sdm_high.n') symbol('sq._sdm_high.'n)

next_msg = sq._sdm_high.n +1
f_msg = sq._root.n'\'next_msg'.MSG'

select
  when stream(f_msg, 'c', 'query exists') <> ''
    then sq._result = -3
  when stream(f_msg, 'c', 'open write') <> 'READY:'
    then sq._result = -3
              /* MSG-Header schreiben */
  when charout(f_msg, msg_hdr) > 0
    then call sq_create_msg_sdm_1
              /* CTRL-Lines schreiben */
  when sq_create_msg_sdm_2() > 0
    then call sq_create_msg_sdm_1
              /* MSG-Text schreiben */
  when charout(f_msg, msg._text.m || '0'x) > 0
    then call sq_create_msg_sdm_1

  otherwise
    call stream f_msg, 'c', 'close'
    sq._sdm_idx.n.0 = sq._sdm_idx.n.0 +1
    y = sq._sdm_idx.n.0
    sq._sdm_idx.n.y = next_msg
    sq._sdm_high.n  = next_msg
    sq._result      = y
end

return



sq_create_msg_sdm_2:
res = 0
if msg._ctrl.m <> ''
  then
  do
    s_begin = 1
    do forever
      s_next = pos('', msg._ctrl.m, s_begin +1)
      if s_next = 0
        then
        do
          res = charout(f_msg, substr(msg._ctrl.m, s_begin) || 'd'x)
          leave
        end
      res = charout(f_msg, substr(msg._ctrl.m, s_begin, s_next -s_begin) || 'd'x)
      s_begin = s_next
    end
  end
return res



sq_create_msg_sdm_1:
call stream f_msg, 'c', 'close'
call sysfiledelete f_msg
sq._result = -3
return

/************************************************************************/

sq_msg_ctrl_mod:

select
  when ctrl_flag = 1
    then
    do
      parse var msg._ctrl.m k1'INTL '.'' +0 k2
      parse value (k1||k2) with k1'TOPT '.'' +0 k2
      parse value (k1||k2) with k1'FMPT '.'' +0 k2
      msg._ctrl.m = k1||k2
    end
  when ctrl_flag = 2
    then
    do
      parse var msg._ctrl.m k1'INTL '.'' +0 k2
      parse value (k1||k2) with k1'TOPT '.'' +0 k2
      parse value (k1||k2) with k1'FMPT '.'' +0 k2
      k0 = 'INTL 'd_zone':'d_net'/'d_node' 'f_zone':'f_net'/'f_node
      if d_point > 0
        then k0 = k0 || 'TOPT 'd_point
      if f_point > 0
        then msg._ctrl.m = k0 || 'FMPT 'f_point || k1 || k2
        else msg._ctrl.m = k0 || k1 || k2
    end
  otherwise
end

return

/************************************************************************/

sq_msg_header_test:

signal on syntax name sq_error_20
parse var msg._from_addr.m f_zone'/'f_node'.'f_point
parse var f_zone f_zone':'f_net'/'
if f_net = ''
  then
  do
    f_net = f_zone
    f_zone = sq._def_zone.n
  end
parse var msg._dest_addr.m d_zone'/'d_node'.'d_point
parse var d_zone d_zone':'d_net'/'
if d_net = ''
  then
  do
    d_net = d_zone
    d_zone = sq._def_zone.n
  end
f_point = ('0'f_point) +0
d_point = ('0'd_point) +0

date_written = sq_datetime2c(msg._date_written.m)
date_arrived = sq_datetime2c(msg._date_arrived.m)
if msg._ftsc_date.m = ''
  then ftsc_date = sq_datetime2ftsc(msg._date_written.m)
  else ftsc_date = msg._ftsc_date.m

select
  when date_written = '' | date_arrived = '' | length(ftsc_date) <> 19
    then sq._result = -20
  when sq._format.n = '$'
    then
    do
      if arg(1) = 0
        then umsgid = sq._hdr_uid.n     /* Neue UMSGID */
      attr = bitor(right(msg._attr.m, 4, '0'x), '00020000'x)
      replies = ''
      do y = msg._replies.m.0 to 1 by -1
        replies = replies || d2c(msg._replies.m.y, 4)
      end
      msg_hdr = reverse(attr)                         ||,
                left(msg._from_name.m, 36, '0'x)      ||,
                left(msg._dest_name.m, 36, '0'x)      ||,
                left(msg._subject.m,   72, '0'x)      ||,
                reverse(d2c(umsgid, 4)              ||,
                        right(replies, 36, '0'x)    ||,
                        d2c(msg._replyto.m, 4)      ||,
                        d2c(msg._utc_ofs.m, 2)      ||,
                        date_arrived                ||,
                        date_written                ||,
                        d2c(d_point, 2)             ||,
                        d2c(d_node, 2)              ||,
                        d2c(d_net, 2)               ||,
                        d2c(d_zone, 2)              ||,
                        d2c(f_point, 2)             ||,
                        d2c(f_node, 2)              ||,
                        d2c(f_net, 2)               ||,
                        d2c(f_zone, 2))               ||,
                ftsc_date || '0'x
    end
  otherwise
    if msg._replies.m.0 = 0
      then replies = 0
      else replies = msg._replies.m.1

    msg_hdr = left(msg._from_name.m, 36, '0'x)      ||,
              left(msg._dest_name.m, 36, '0'x)      ||,
              left(msg._subject.m,   72, '0'x)      ||,
              ftsc_date || '0'x                     ||,
              reverse(d2c(replies, 2)             ||,
                      right(msg._attr.m, 2, '0'x) ||,
                      d2c(msg._replyto.m, 2)      ||,
                      date_arrived                ||,
                      date_written                ||,
                      d2c(d_net, 2)               ||,
                      d2c(f_net, 2)               ||,
                      d2c(msg._cost.m, 2)         ||,
                      d2c(f_node, 2)              ||,
                      d2c(d_node, 2)              ||,
                      d2c(msg._times_read.m, 2))
end

return sq._result



/************************************************************************/

sq_uid_2_num: procedure expose sq. msg.

arg n, uid, flag

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98
  otherwise
    if sq._format.n = '$'
      then sum = length(sq._area_idx.n) % 12  /* Anzahl der Index-Eintrge */
      else
      do
        call sq_sort_sdm_idx
        sum = sq._sdm_idx.n.0
      end
    ug = 0; og = sum +1           /* Suchgrenzen */
    do forever
      i = (ug + og) % 2
      if ug = i                   /* nicht gefunden */
        then
        do
          if flag = '+'
            then i = (i +1) * (i < sum)
            else if flag <> '-'
              then i = 0
          leave
        end
      if sq._format.n = '$'
        then t = c2d(reverse(substr(sq._area_idx.n, i * 12 -7, 4, '0'x)))
        else t = sq._sdm_idx.n.i
      if uid < t
        then og = i           /* weiter unten suchen */
        else if uid > t
          then ug = i         /* weiter oben suchen */
          else leave          /* gefunden */
    end
    sq._result = i
end

return sq._result

/************************************************************************/

sq_num_2_uid: procedure expose sq. msg.

arg n, ser

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98
  when \datatype(ser, 'w') | ser < 1
    then sq._result = -99
  when sq._format.n = '$'
    then sq._result = c2d(reverse(substr(sq._area_idx.n, ser * 12 -7, 4, '0'x)))
  when ser > sq._sdm_idx.n.0
    then sq._result = 0
  otherwise
    call sq_sort_sdm_idx
    sq._result = sq._sdm_idx.n.ser
end

return sq._result

/************************************************************************/

sq_close_area: procedure expose sq. msg.

arg n .

sq._result = 0
p = wordpos(n, sq._open_areas)
select
  when p = 0
    then sq._result = -98
  when sq._msg_current.n <> 0
    then sq._result = -5
  when sq._format.n <> '$'    /* *.MSG-Area schliessen */
    then call sq_close_area_1
  otherwise
    select
      when sq._modified.n = 0
        then nop
      when sysfiledelete(sq._root_sqi.n) > 2
        then sq._result = -2
      when stream(sq._root_sqi.n, 'c', 'open') <> 'READY:'
        then sq._result = -2
      otherwise
        if charout(sq._root_sqi.n, sq._area_idx.n) > 0
          then sq._result = -2
        call stream sq._root_sqi.n, 'c', 'close'
    end
    call stream sq._root_sqd.n, 'c', 'close'
    call sq_close_area_1
end
signal off syntax

return sq._result


sq_close_area_1:
sq._open_areas = strip(delword(sq._open_areas, p, 1))
p = wordpos(sq._root.n, sq._open_roots)
if p > 0
  then sq._open_roots = strip(delword(sq._open_roots, p, words(sq._root)))
return

/************************************************************************/

sq_update_area_hdr: procedure expose sq. msg.

arg n

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when sq._format.n <> '$'
    then sq._result = -21         /* keine Squish-Area */
  otherwise
    sq._result = 0
    call sq_write_header
end

return sq._result

/************************************************************************/

sq_write_header:

signal on syntax name sq_error_1
if charout(sq._root_sqd.n,,
     reverse(d2c(sq._hdr_uid.n            , 4) ||,
             d2c(sq._hdr_high_water.n     , 4) ||,
             d2c(sq._hdr_skip_msg.n       , 4) ||,
             d2c(sq._hdr_high_msg.n       , 4) ||,
             d2c(sq._hdr_num_msg.n        , 4) ||,
             d2c(sq._hdr_reserved_1.n     , 2) ||,
             d2c(sq._hdr_len.n            , 2))   ||,
     left(sq._hdr_base.n, 80, '0'x)               ||,
     reverse(d2c(sq._hdr_sz_sqhdr.n       , 2) ||,
             d2c(sq._hdr_keep_days.n      , 2) ||,
             d2c(sq._hdr_max_msg.n        , 4) ||,
             d2c(sq._hdr_end_frame.n      , 4) ||,
             d2c(sq._hdr_last_free_frame.n, 4) ||,
             d2c(sq._hdr_free_frame.n     , 4) ||,
             d2c(sq._hdr_last_frame.n     , 4) ||,
             d2c(sq._hdr_begin_frame.n    , 4))   ||,
     left(sq._hdr_reserved_2.n, 124, '0'x) ,1) > 0
  then sq._result = -1

return sq._result

/************************************************************************/

sq_open_area: procedure expose sq. msg.

arg n, root, a_format, open_cmd, zone

actdir     = directory()
sq._result = 0

root_path = strip(filespec('d', root) || filespec('p', root), 't', '\')
if right(root_path, 1) = ':'
  then root_path = root_path'\'
root_path = translate(strip(directory(root_path), 't', '\'))

select
  when root_path = '' | \datatype(n, 'w') | n < 0 |,
       (zone <> '' & (\datatype(zone, 'w') | zone < 1))
    then sq._result = -99
  when wordpos(root, sq._open_roots) > 0
    then sq._result = -97
  when wordpos(n, sq._open_areas) > 0
    then sq._result = -98
  otherwise
    if zone = ''
      then sq._def_zone.n = sq._def_zone
      else sq._def_zone.n = zone
    sq._root.n          = root_path'\'filespec('n', root)
    sq._msg_current.n   = 0
    sq._msg_last.n      = 0
    if a_format = '$'
      then call sq_open_area_sq
      else call sq_open_area_sdm
end
call directory actdir

return sq._result



sq_open_area_sq:

sq._root_sqd.n      = sq._root.n'.SQD'
sq._root_sqi.n      = sq._root.n'.SQI'
sq._format.n        = '$'

if open_cmd = 'C'             /* Area neu erstellen */
  then
  do
    res = sysfiledelete(sq._root_sqd.n)
    select
      when res = 32 | res = 5
        then res = -1      /* Zugriff verweigert */
      when res > 2
        then res = 0       /* Fehler */
      otherwise
        call sq_open_area_sq_1
    end
  end
  else
  do
    size = stream(sq._root_sqd.n, 'c', 'query size')
    select
      when open_cmd = 'N' & size = ''  /* Area erstellen, wenn nicht vorhanden */
        then call sq_open_area_sq_1
      when size = ''
        then res = 0             /* Fehler, Area nicht vorhanden */
      otherwise                       /* Area ffnen, wenn vorhanden */
        parse value stream(sq._root_sqd.n, 'c', 'open') with ':'res
        select
          when res = ''
            then res = 2            /* Area geffnet */
          when res = 32 | res = 5
            then res = -1           /* Zugriff verweigert */
          otherwise
            res = 0                 /* Fehler */
        end
    end
  end

        /* Status RES: -1 = Zugriff verweigert
                        0 = Fehler
                        1 = Area erstellt
                        2 = geffnet */

select
  when res = -1             /* Zugriff verweigert */
    then sq._result = -4
  when res = 0              /* Fehler beim ffnen */
    then sq._result = -1
  when res = 1              /* File neu erstellt */
    then
    do
      sq._hdr_len.n             = 256    /* Lnge des Headers */
      sq._hdr_reserved_1.n      = 0
      sq._hdr_num_msg.n         = 0
      sq._hdr_high_msg.n        = 0
      sq._hdr_skip_msg.n        = 0
      sq._hdr_high_water.n      = 0
      sq._hdr_uid.n             = 1
      sq._hdr_base.n            = copies('0'x, 80)
      sq._hdr_begin_frame.n     = 0
      sq._hdr_last_frame.n      = 0
      sq._hdr_free_frame.n      = 0
      sq._hdr_last_free_frame.n = 0
      sq._hdr_end_frame.n       = sq._hdr_len.n
      sq._hdr_max_msg.n         = 0
      sq._hdr_keep_days.n       = 0
      sq._hdr_sz_sqhdr.n        = 28
      sq._hdr_reserved_2.n      = copies('0'x, 124)

      if sq_write_header() <> 0
        then sq._result = -1
        else
        do
          call sysfiledelete sq._root_sqi.n
          sq._area_idx.n = ''
          sq._modified.n = 1
          sq._open_areas = sq._open_areas n
          sq._open_roots = sq._open_roots sq._root.n
        end
    end
  otherwise

    parse value charin(sq._root_sqd.n,, 256) with,
                       data1           +24,
                       sq._hdr_base.n  +80,
                       data2           +28,
                       sq._hdr_reserved_2.n
    parse value reverse(data1) with,
                       sq._hdr_uid.n             +4,
                       sq._hdr_high_water.n      +4,
                       sq._hdr_skip_msg.n        +4,
                       sq._hdr_high_msg.n        +4,
                       sq._hdr_num_msg.n         +4,
                       sq._hdr_reserved_1.n      +2,
                       sq._hdr_len.n             +2
    parse value reverse(data2) with,
                       sq._hdr_sz_sqhdr.n        +2,
                       sq._hdr_keep_days.n       +2,
                       sq._hdr_max_msg.n         +4,
                       sq._hdr_end_frame.n       +4,
                       sq._hdr_last_free_frame.n +4,
                       sq._hdr_free_frame.n      +4,
                       sq._hdr_last_frame.n      +4,
                       sq._hdr_begin_frame.n     +4

    sq._hdr_len.n             = c2d(sq._hdr_len.n)
    sq._hdr_reserved_1.n      = c2d(sq._hdr_reserved_1.n)
    sq._hdr_num_msg.n         = c2d(sq._hdr_num_msg.n)
    sq._hdr_high_msg.n        = c2d(sq._hdr_high_msg.n)
    sq._hdr_skip_msg.n        = c2d(sq._hdr_skip_msg.n)
    sq._hdr_high_water.n      = c2d(sq._hdr_high_water.n)
    sq._hdr_uid.n             = c2d(sq._hdr_uid.n)

    sq._hdr_begin_frame.n     = c2d(sq._hdr_begin_frame.n)
    sq._hdr_last_frame.n      = c2d(sq._hdr_last_frame.n)
    sq._hdr_free_frame.n      = c2d(sq._hdr_free_frame.n)
    sq._hdr_last_free_frame.n = c2d(sq._hdr_last_free_frame.n)
    sq._hdr_end_frame.n       = c2d(sq._hdr_end_frame.n)
    sq._hdr_max_msg.n         = c2d(sq._hdr_max_msg.n)
    sq._hdr_keep_days.n       = c2d(sq._hdr_keep_days.n)
    sq._hdr_sz_sqhdr.n        = c2d(sq._hdr_sz_sqhdr.n)

    select
      when sq._hdr_num_msg.n <> sq._hdr_high_msg.n |,
           stream(sq._root_sqd.n, 'c', 'query size') <> sq._hdr_end_frame.n |,
           length(sq._hdr_reserved_2.n) < 124
        then
        do
          call stream sq._root_sqd.n, 'c', 'close'
          sq._result = -10
        end
      when sq_open_area_read_sqi() <> 0
        then call stream sq._root_sqd.n, 'c', 'close'
      otherwise
        sq._modified.n = 0
        sq._open_areas = sq._open_areas n
        sq._open_roots = sq._open_roots sq._root.n
    end
end

return



sq_open_area_sq_1:
if stream(sq._root_sqd.n, 'c', 'open') = 'READY:' &,
   charout(sq._root_sqd.n, '0'x) = 0
  then
  do
    call stream sq._root_sqd.n, 'c', 'close'
    res = (stream(sq._root_sqd.n, 'c', 'open') = 'READY:')
  end
  else res = 0
return


sq_open_area_read_sqi:

select
  when sq._hdr_num_msg.n = 0      /* SQI braucht nicht eingelesen werden */
    then sq._area_idx.n = ''
  when stream(sq._root_sqi.n, 'c', 'open read') <> 'READY:'
    then sq._result = -2          /* Fehler beim ffnen von SQI */
  otherwise
    req_sqi = sq._hdr_num_msg.n * 12
    sq._area_idx.n = charin(sq._root_sqi.n,, req_sqi)
    call stream sq._root_sqi.n, 'c', 'close'
    s = 0
    if length(sq._area_idx.n) <> req_sqi
      then sq._result = -11
      else
      do until sq._result < 0
        s = pos('00000000'x'ffffffff'x, sq._area_idx.n, s +1) -1
        select
          when s >= 0
            then if s // 12 = 0   /* Invalid Frames in SQI */
              then sq._result = -11
          when c2d(reverse(left(sq._area_idx.n, 4))) <> sq._hdr_begin_frame.n |,
               c2d(reverse(substr(sq._area_idx.n, req_sqi -11, 4))) <> sq._hdr_last_frame.n |,
               c2d(reverse(substr(sq._area_idx.n, req_sqi  -7, 4))) >= sq._hdr_uid.n
            then sq._result = -11
          otherwise
            leave
        end
      end
end
return sq._result



sq_open_area_sdm:

sq._format.n  = ''
select
  when open_cmd = 'C'    /* Area neu erstellen */
    then call sq_open_area_sdm_1

  when open_cmd <> 'N'   /* Area ffnen, wenn vorhanden */
    then sq._result = (directory(sq._root.n) = '')

  when directory(sq._root.n) = ''
                /* Area erstellen, wenn nicht vorhanden */
    then call sq_open_area_sdm_1
  otherwise
end
if sq._result = 0
  then
  do
    call sysfiletree '*.MSG', 'data', 'fo'
    z = 0
    do y = 1 to data.0
      parse upper value filespec('n', data.y) with uid'.MSG'
      if datatype('0'uid, 'w') & uid > 0
        then
        do
          z = z +1
          sq._sdm_idx.n.z = uid
        end
    end
    sq._sdm_idx.n.0 = z
    sq._sdm_sort.n  = 0
    sq._sdm_high.n  = 0
    do y = 1 to sq._sdm_idx.n.0
      if sq._sdm_idx.n.y > sq._sdm_high.n
        then sq._sdm_high.n = sq._sdm_idx.n.y
    end
    sq._open_areas = sq._open_areas n
    sq._open_roots = sq._open_roots sq._root.n
  end

sq._result = sq._result * -3

return sq._result


sq_open_area_sdm_1:
if sysmkdir(sq._root.n) = 0
  then sq._result = (directory(sq._root.n) = '')
  else sq._result = 1
return

/************************************************************************/

sq_area_valid: procedure expose sq. msg.

arg root, a_format

select
  when root = ''
    then sq._result = -99
  when a_format <> '$'    /* *.MSG-Area testen */
    then
    do
      actdir = directory()
      if directory(root) = ''
        then sq._result = -3
        else sq._result = 0
      call directory actdir
    end
                          /* Squish-Area testen */
  when stream(root'.SQD', 'c', 'query exists') = ''
    then sq._result = -1
  when stream(root'.SQI', 'c', 'query exists') = ''
    then sq._result = -2
  otherwise
    sq._result = 0
end

return sq._result

/************************************************************************/

sq_sort_sdm_idx:

if \sq._sdm_sort.n
  then
  do
    call sq_sort_sdm_idx_r 1, sq._sdm_idx.n.0
    sq._sdm_sort.n = 1
  end
return


sq_sort_sdm_idx_r: procedure expose n sq.

arg lf, re
if re -lf < 9
  then
  do lf = lf to re -1
    m = lf
    do j = lf +1 to re
      if sq._sdm_idx.n.j < sq._sdm_idx.n.m
        then m = j
    end
    t = sq._sdm_idx.n.m; sq._sdm_idx.n.m = sq._sdm_idx.n.lf; sq._sdm_idx.n.lf = t
  end
  else
  do
    i = (re + lf) %2
    call sq_sort_sdm_idx_r lf, i
    call sq_sort_sdm_idx_r i +1, re
    p  = i +1
    do r = lf to i
      hp.r = sq._sdm_idx.n.r
    end

    do r = lf to re while lf <= i
      select
        when p > re
          then
          do r = r to re
            sq._sdm_idx.n.r = hp.lf
            lf = lf +1
          end
        when hp.lf < sq._sdm_idx.n.p
          then
          do
            sq._sdm_idx.n.r = hp.lf
            lf = lf +1
          end
        otherwise
          sq._sdm_idx.n.r = sq._sdm_idx.n.p
          p = p +1
      end
    end
  end

return

/************************************************************************/

/* Datum/Zeit in FTSC-Format wandeln */
sq_datetime2ftsc: procedure

arg dt
signal on syntax name sq_error_null

if dt = ''
  then dt = insert(' 'word(date('n'), 2)' ', delstr(date('e'), 3, 4), 2)'  'time('n')
  else
  do
    parse var dt year'/'mon'/'day'-'hr':'min':'sec
    if mon < 13
      then dt = right(day+0, 2, 0)' '||,
           word('Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec', mon)' '||,
           right(year+0, 2, 0)'  '||,
           right(hr+0, 2, 0)':'right(min+0, 2, 0)':'right(sec+0, 2, 0)
      else dt = ''
  end
return dt

/************************************************************************/

/* Datum/Zeit in Squish-Format wandeln */
sq_datetime2c: procedure

arg dt
if dt = ''
  then dt = date('o')'-'time('n')
parse var dt year'/'mon'/'day'-'hr':'min':'sec
signal on syntax name sq_error_null
select
  when year > 99
    then year = year -1980
  when year >= 80
    then year = year - 80
  otherwise
    year = year +20
end
dt = d2c(sec %2 + min *32 + hr *2048, 2) || d2c(day + mon *32 + year *512, 2)
return dt

/************************************************************************/

/* Squish-Format in lesbares Format wandeln */
sq_c2datetime: procedure

parse arg tm +2 dt

dt = c2d(dt) % 512 +1980                        || '/' || ,
     right(c2d(bitand(dt, '01e0'x)) % 32, 2, 0) || '/' || ,
     right(c2d(bitand(dt, '001f'x))     , 2, 0) || '-' || ,
     right(c2d(tm) % 2048               , 2, 0) || ':' || ,
     right(c2d(bitand(tm, '07e0'x)) % 32, 2, 0) || ':' || ,
     right(c2d(bitand(tm, '001f'x)) *2  , 2, 0)

return dt

/************************************************************************/

/* HASH */

sq_str_hash: procedure

arg str, flag
str = translate(str, xrange('a', 'z'), xrange('A', 'Z'))
hash = '00000000'x
do y = 1 to length(str)
  hash = d2c(x2d(substr(c2x(hash), 2)'0') + c2d(substr(str, y, 1)), 4)
  g = bitand(hash, 'f0000000'x)
  if g <> '00000000'x
    then hash = bitor('000000'x || left(g ,1), bitor(g, hash))
end
if flag > 0
  then hash =  bitor(hash, '80000000'x)
  else hash = bitand(hash, '7fffffff'x)

return hash

/************************************************************************/

sq_error_20:
sq._result = -20
return sq._result

sq_error_1:
sq._result = -1
return sq._result

sq_error_null:
return ''

/************************************************************************/




